#include <stdio.h>
#include <stdlib.h>
#include <string.h>





static unsigned int get_word(unsigned char *p){
	unsigned int t;
	t = p[1];
	t = ((t << 8) | p[0]);
	return t;
}

static unsigned long get_dword(unsigned char *p){
	unsigned long t;
	t = p[3];
	t = ((t << 8) | p[2]);
	t = ((t << 8) | p[1]);
	t = ((t << 8) | p[0]);
	return t;
}




int main(int argc, char *argv[]){
	unsigned char *src;
	long size;

	if(2 > argc){
		exit(0);
	}

	{
		FILE *fp;
		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			printf("%s ݂͑܂\n", argv[1]);
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		src = malloc(size);
		if(NULL == src){
			fclose(fp);
			puts("mۂł܂ł");
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(src, 1, size, fp);
		fclose(fp);
	}


	{
		FILE *fp;
		char name[32];
		long ofs, t_ofs;
		unsigned int t_size;
		int k, num;

		num = get_word(src);
		ofs = 2;
		for(k = 0; num > k; ++k){
			t_ofs = get_dword(src + ofs);
			t_size = get_word(src + ofs + 4);
			if(0 == t_size){
				ofs += 6;
				continue;
			}
			sprintf(name, "IKO_%02d.OPI", k);
			fp = fopen(name, "wb");
			fwrite((src + t_ofs), 1, t_size, fp);
			fclose(fp);
			ofs += 6;
		}
	}

	free(src);

	exit(0);
}
